﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head><title>Dynamic Attributes in Analytics</title>
    </head>
    <body>
        <h1>Dynamic Attributes in Analytics</h1>
        <p>The Analytics module enables you to define SQL queries to obtain the required information from the database. You can add both static and dynamic attribute values in the WHERE condition of the query. Static attribute values are pre-defined to return specific results. The Dynamic attributes add flexibility to change the filter condition values passed in the queries at run time for varied results. Unlike static attributes, dynamic attributes are not embedded in your SQL query. Instead, they are entered from the user interface while creating the Analytics configuration and built by the query at run time. Support for dynamic attributes is available for both Elasticsearch and non-Elasticsearch run time analytics. For SQL Query based controls, although dynamic attributes can be configured, the control is always executed with the default value of the saved dynamic attribute while creating or editing the reports. While running SQL query based controls, users will not be prompted to enter the dynamic value.</p>
        <p>Below is a sample SQL query containing dynamic attributes.</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city='${city}'and employeetype='${etype}': </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>This example will query the users table for users by username, firstname, and lastname fields while allowing you to define multiple values for city and etype at run time.</p>
        <p>You can define dynamic attributes at run time in both merged and non-merged interface.</p>
    </body>
</html>